
{$APPTYPE GUI}
{$MODE DELPHI}

uses
  Messages, Windows, Cairo, CairoWin32;

{$R wincairo.res}

const
  CLASSNAME = 'FENETRE_SANS_BORDURE_PLEIN_ECRAN';

var
  gHandle: HWND;
  gWidth, gHeight: integer;

procedure Dessin(aDC: HDC);
var
  cr: pcairo_t;
  surface: pcairo_surface_t;
begin
  surface := cairo_win32_surface_create_with_dib(CAIRO_FORMAT_ARGB32, gHeight, gHeight);
  
  cr := cairo_create(surface);
  cairo_scale(cr, gHeight, gHeight);
  cairo_set_source_rgb(cr, 1, 1, 1);
  cairo_paint(cr);
  cairo_set_source_rgb(cr, 1, 0, 0);
  cairo_set_line_width(cr, 0.1);
  cairo_move_to(cr, 0.2, 0.2);
  cairo_line_to(cr, 0.8, 0.8);
  cairo_stroke(cr);
  cairo_destroy(cr);
  
  BitBlt(
    aDC,
    (gWidth - gHeight) div 2,
    0,
    gHeight,
    gHeight,
    cairo_win32_surface_get_dc(surface),
    0,
    0,
    SRCCOPY
  );
  
  cairo_surface_destroy(surface);
end;

function WndProc(aHandle: HWND; aMsg: UINT; wp: WPARAM; lp: LPARAM): LRESULT; stdcall;
var
  vPS: TPaintStruct;
  vDC: HDC;
begin
  case aMsg of
    WM_KEYDOWN: 
      //if wp = VK_ESCAPE then
      begin
        PostQuitMessage(0);
        result := 0;
        exit;
      end;
    WM_DESTROY: 
      begin
        PostQuitMessage(0);
        result := 0;
        exit;
      end;
    WM_PAINT:   
      begin
        vDC := BeginPaint(gHandle, vPS);
        Dessin(vDC);
        EndPaint(gHandle, vPS);
        result := 0;
        exit;
      end;
  end;
  result := DefWindowProc(aHandle, aMsg, wp, lp);
end;

var
  vClass: TWndClass;
  vMsg: TMsg;

begin
  vClass.Style := CS_VREDRAW or CS_HREDRAW;
  vClass.lpfnWndProc := @WndProc;
  vClass.cbClsExtra := 0;
  vClass.cbWndExtra := 0;
  vClass.hInstance := system.hInstance;
  vClass.hIcon := LoadIcon(hInstance, IDI_APPLICATION);
  vClass.hCursor := LoadCursor(hInstance, IDC_ARROW);
  vClass.hbrBackground := GetStockObject(BLACK_BRUSH);
  vClass.lpszMenuName := nil;
  vClass.lpszClassName:= CLASSNAME;
  RegisterClass(vClass);

  gWidth := GetSystemMetrics(SM_CXSCREEN);
  gHeight := GetSystemMetrics(SM_CYSCREEN);

  gHandle := CreateWindow(CLASSNAME, '', WS_POPUP or WS_VISIBLE, 0, 0, gWidth, gHeight, 0, 0, hInstance, nil);

  ShowWindow(gHandle, CmdShow);
  UpdateWindow(gHandle);

  while TRUE do
    if PeekMessage(vMsg,0,0,0, PM_REMOVE) then
    begin
      if vMsg.message = WM_QUIT then
        Break;
      TranslateMessage(vMsg);
      DispatchMessage(vMsg);
    end;

  ExitProcess(vMsg.wParam);
end.
