{$APPTYPE GUI}
{$MODE DELPHI}
 
uses
  Windows, Cairo, CairoWin32;
 
{$R wincairo.res}
 
const
  CLASSNAME = 'FENETRE_DESSIN';
 
var
  gHandle: THandle;
 
procedure CairoDraw(aDC: HDC; aClientWidth, aClientHeight: integer);
var
  cr: pcairo_t;
  surface: pcairo_surface_t;
begin
  surface := cairo_win32_surface_create_with_dib(CAIRO_FORMAT_ARGB32, aClientWidth, aClientHeight);
 
  cr := cairo_create(surface);
  cairo_scale(cr, aClientWidth, aClientHeight);
  cairo_set_source_rgb(cr, 1, 1, 1);
  cairo_paint(cr);
  cairo_set_source_rgb(cr, 1, 0, 0);
  cairo_set_line_width(cr, 0.1);
  cairo_move_to(cr, 0.2, 0.2);
  cairo_line_to(cr, 0.8, 0.8);
  cairo_stroke(cr);
  cairo_destroy(cr);
 
  BitBlt(
    aDC,
    0,
    0,
    aClientWidth,
    aClientHeight,
    cairo_win32_surface_get_dc(surface),
    0,
    0,
    SRCCOPY
  );
 
  cairo_surface_destroy(surface);
end;
 
function WinProc(aHandle: THandle; aMsg: UINT; aWP: WPARAM; aLP: LPARAM): LRESULT; stdcall;
var
  vPS: TPaintStruct;
  vDC: HDC;
  vRECT: RECT;
begin
  case aMsg of
    WM_SIZE:
      begin
        {
        InvalidateRect(aHandle, nil, TRUE);
        UpdateWindow(aHandle);
        }
      end;
    WM_KEYDOWN:
      if aWP = VK_ESCAPE then
      begin
        PostQuitMessage(0);
        result := 0;
        exit;
      end;
    WM_DESTROY:
      begin
        PostQuitMessage(0);
        result := 0;
        exit;
      end;
    WM_PAINT:
      begin
        vDC := BeginPaint(gHandle, vPS);
        GetClientRect(aHandle, @vRECT);
        CairoDraw(vDC, vRECT.right - vRECT.left, vRECT.bottom - vRECT.top);
        EndPaint(gHandle, vPS);
        result := 0;
        exit;
      end;
  end;
  result := DefWindowProc(aHandle, aMsg, aWP, aLP);
end;
 
procedure TextMode;
begin
  DestroyWindow(gHandle);
end;
 
procedure DoEvents;
var
  vMsg: TMsg;
begin
  while PeekMessage(vMsg, 0, 0, 0, PM_REMOVE) do
  begin
    TranslateMessage(vMsg);
    DispatchMessage(vMsg);
    if vMsg.Message = WM_QUIT then
    begin
      TextMode;
      Halt;
    end;
  end; 
end;
 
procedure GraphMode(aClientWidth, aClientHeight: integer);
var
  vClass: TWndClass;
  vBorder, vCaption, vWidth, vHeight, vLeft, vTop: integer;
begin
  vClass.style := CS_HREDRAW or CS_VREDRAW;;
  vClass.lpfnWndProc := @WinProc;
  vClass.cbClsExtra := 0;
  vClass.cbWndExtra := 0;
  vClass.hInstance := system.hInstance;
  vClass.hIcon := LoadImage(hInstance, MAKEINTRESOURCE(1), IMAGE_ICON, 0, 0, 0);
  vClass.hCursor := LoadCursor(0, IDC_ARROW);
  vClass.hbrBackground := GetStockObject(WHITE_BRUSH);;
  vClass.lpszMenuName := nil;
  vClass.lpszClassName := CLASSNAME;
 
  if RegisterClass(vClass) = 0 then
    Halt;
 
  vBorder := 2 * (GetSystemMetrics(SM_CXDLGFRAME) + GetSystemMetrics(SM_CXBORDER));
  vCaption := GetSystemMetrics(SM_CYCAPTION);
 
  vWidth := aClientWidth + 2 * vBorder;
  vHeight := aClientHeight + 2 * vBorder + vCaption;
  vLeft := (GetSystemMetrics(SM_CXFULLSCREEN) - vWidth) div 2;
  vTop := (GetSystemMetrics(SM_CYFULLSCREEN) - vHeight) div 2;
 
  gHandle := CreateWindow(
    CLASSNAME,
    'Dessin avec Cairo',
    WS_OVERLAPPEDWINDOW or WS_VISIBLE,
    vLeft,
    vTop,
    vWidth,
    vHeight,
    0,
    0,
    hInstance,
    nil
  );
 
  if gHandle = 0 then
    Halt;
end;
 
begin
  GraphMode(400, 400);
  while TRUE do
    DoEvents;
end. 
